#include <fstream>
#include <cstring>

//#define MAPTECH

#define LOA 0
#define STO 1
#define ADD 2
#define MUL 3

char opstr[4][4]={"LOA","STO","ADD","MUL"};

struct oper {
  int c,p;
};

long long m[10000];
char s[256];
int sl=0;
int oc=0;
oper o[200000];
ifstream fin("assem.inp");
ofstream fout("assem.out");


void exec(int c,int p)
{
  switch (c){
    case LOA:m[0]=m[p];break;
    case STO:m[p]=m[0];break;
    case ADD:m[0]+=m[p];break;
    case MUL:m[0]*=m[p];break;
  }
}

void exec(oper x) {exec(x.c,x.p);}

int map[10000];

void add(int c,int p)
{
#ifdef MAPTECH
  if ((c==STO)&&(oc>=1))
    if (o[oc-1].c==LOA)
    {
      oc--;
      map[p]=o[oc].p;
      return;
    }
#endif
  o[oc].c=c;
  o[oc].p=p;
  oc++;
}


void expr(int&,int&);
void term(int&,int&);
void sum (int&,int&);


void expr(int &p,int &mp)
{
  sum(p,mp);
  while ((s[p]=='+')||(s[p]=='*'))
  {
    char sp=s[p];
    add(STO,mp);mp++;
    sum(p,mp);mp--;
    switch (sp) {
      case '*':add(MUL,mp);
      case '+':add(ADD,mp);
    }
    p++;
  }
}


void sum(int &p,int &mp)
{
  term(p,mp);
  while (s[p]=='+')
  {
    add(STO,mp);mp++;
    p++;
    term(p,mp);mp--;
    add(ADD,mp);
  }
}


void term(int &p,int &mp)
{
//  bool ob=false;
  if (s[p]=='(')
  {
    p++;
    expr(p,mp);
    p++;
    if (s[p]!='*') return;
  }
  else
  {
    p++;
    add(LOA,s[p]-'0');
    p++;
    if (s[p]!='*') return;
  }

  p++;
  while (true)
  {
    if (s[p]=='(')
    {
      add(STO,mp); mp++;
      p++;
      expr(p,mp);mp--;
      p++;
      add(MUL,mp);
      if (s[p]!='*') return;
    }
    else
    {
      p++;
      add(MUL,s[p]-'0');
      p++;
      if (s[p]!='*') return;
    }
    p++;
  }
}


int main()
{
  memset(s,0,sizeof(s));
  for (int i=1;i<=10000;i++) map[i]=i;
  
  for (int i=1;i<=9;i++) fin >> m[i];
  fin >> s; sl=strlen(s);

  int max=0;
  for (int i=0;i<sl;i++)
    if (('0'<=s[i])&&(s[i]<='9')) max=(max>(s[i]-'0')?max:(s[i]-'0'));

  max++;

  int p=0;
  expr(p,max);

  for (int i=0;i<oc;i++)
  {
    o[i].p=map[o[i].p];
    exec(o[i]);
  }
  
  fout << m[0] << endl << oc << endl;
  for (int i=0;i<oc;i++)
    fout << opstr[o[i].c] << " " << o[i].p << endl;
  
  return 0;
}
