Const
        InFile = 'assem.inp';
        OutFile = 'assem.out';

Type
        TLong = record
                d : array [0..100] of byte;
                n : integer;
        end;

        TNode = record
                znak : char;
                addr : integer;
        end;

        TCommand = record
                c    : char;
                addr : integer;
        end;

Var
        FIn,FOut : text;
        n,i,j    : longint;
        s        : string;
        a        : array [1..200] of TLong;
        steck    : array [1..1000] of char;
        rSteck   : array [1..2000] of TNode;
        count    : longint;
        cs       : array [1..10000] of TCommand;
        csCount  : longint;


procedure toLong(var a : TLong; b : longint);
var
        i : integer;

begin
        a.n := 0;
        fillchar(a.d,sizeof(a.d),0);
        while b > 0 do begin
                a.d[a.n] := b mod 10;
                b := b div 10;
                inc(a.n);
        end;

        if a.n > 0 then
                dec(a.n);
end;

function max(a,b : integer) : integer;
begin
        if a > b then
                max := a
        else
                max := b;
end;

procedure add(var a : TLong; b : TLong);
var
        i,j : integer;

begin
        a.n := max(a.n,b.n);
        j := 0;
        for i := 0 to a.n do begin
                j := a.d[i] + j + b.d[i];
                a.d[i] := j mod 10;
                j := j div 10;
        end;
        if j > 0 then begin
                inc(a.n);
                a.d[a.n] := 1;
        end;
end;

procedure mul(var a : TLong; b : TLong);
var
        i,j : integer;
        t   : TLong;
        k,p : integer;

begin
        t.n := 0;
        fillchar(t.d,sizeof(t.d),0);
        for i := 0 to a.n do
                for j := 0 to b.n do begin
                        k := t.d[ i + j] + a.d[i] * b.d[j];
                        t.d[i + j] := k mod 10;
                        k := k div 10;
                        p := i + j;
                        while k > 0 do begin
                                inc(p);
                                k := t.d[p] + k;
                                t.d[p] := k mod 10;
                                k := k div 10;
                        end;
                end;
        for k := 100 downto 0 do
                if t.d[k] <> 0 then begin
                        t.n :=k;
                        break;
                end;
        a := t;
end;

procedure print(var a : TLong);
var
        i : integer;
begin
        for i := a.n downto 0 do
                write(FOut,a.d[i]);
        writeln(FOut);
end;

procedure solve;
var
        i : integer;
        s1 : string;
        z  : TLong;

        ID : integer;

        load : boolean;

begin
        while pos(' ',s) <> 0 do
                delete(s,pos(' ',s),1);

        s := '(' + s + ')';
        n := 0; count := 0;

        while s <> '' do begin
                case s[1] of
                        'X','x' : begin
                                s1 := s[2];
                                inc(count);
                                rSteck[count].znak := '!';
                                val(s1,rSteck[count].addr,i);
                                delete(s,1,2);
                        end;
                        '*' : begin
                                while (steck[n] <> '(') and (steck[n] <> '+') do begin
                                        inc(count);
                                        rSteck[count].znak := steck[n];
                                        dec(n);
                                end;
                                inc(n);
                                steck[n] := '*';
                                delete(s,1,1);
                        end;
                        '+' : begin
                                while steck[n] <> '(' do begin
                                        inc(count);
                                        rSteck[count].znak := steck[n];
                                        dec(n);
                                end;
                                inc(n);
                                steck[n] := '+';
                                delete(s,1,1);
                        end;
                        '(' : begin
                                inc(n);
                                steck[n] := '(';
                                delete(s,1,1);
                        end;
                        ')' : begin
                                while steck[n] <> '(' do begin
                                        inc(count);
                                        rSteck[count].znak := steck[n];
                                        dec(n);
                                end;
                                dec(n);
                                delete(s,1,1);
                        end;
                end;
        end;

        csCount := 0;
        toLong(z,0);

        id := 15;
        load := false;

        for i := 1 to count do
                if rSteck[i].znak = '!' then begin
                        if load then begin
                                inc(csCount);
                                cs[csCount].c := 'S';
                                inc(ID);
                                cs[csCount].addr := ID;
                                a[ID] := Z;
                        end;
                        inc(csCount);
                        cs[csCount].c := 'L';
                        cs[csCount].addr := rSteck[i].addr;
                        z := a[rSteck[i].addr];
                        load := true;
                end
                else begin
                        if rSteck[i].znak = '+' then begin
                                inc(csCount);
                                cs[csCount].c := 'A';
                                cs[csCount].addr := ID;
                                add(Z,a[id]);
                                dec(ID);
                        end
                        else begin
                                inc(csCount);
                                cs[csCount].c := 'M';
                                cs[csCount].addr := ID;
                                mul(z,a[id]);
                                dec(ID);
                        end;
                end;

                print(Z);
                writeln(FOut,csCount);
                for i := 1 to csCount do begin
                        case cs[i].c of
                                'A' : write(FOut,'ADD ');
                                'M' : write(FOut,'MUL ');
                                'L' : write(FOut,'LOA ');
                                'S' : write(FOut,'STO ');
                        end;
                        writeln(FOut,cs[i].addr);
                end;
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);
        for i := 1 to 8 do begin
                read(FIn,j);
                toLong(a[i],j);
        end;
        readln(FIn,J);
        toLong(a[9],j);
        readln(FIn,S);
        close(FIn);
        solve;
        close(FOut);
End.
