Const
        InFile = 'Pass.inp';
        OutFile = 'Pass.out';

        MAXN = 350000;

Type
        STR = array [1..350] of char;

Var
        FIn,FOut : text;
        a        : array [1..MAXN] of char;
        d        : array [1..MAXN] of longint;
        b        : array [1..350] of STR;
        len      : array [1..350] of longint;
        n,m      : longint;
        i,k      : longint;

function min(a,b : longint) : longint;
begin
        if a < b then
                min := a
        else
                min := b;
end;

procedure solve;
var
        i,j,k,l : longint;
        flag    : boolean;

begin
        d[n+1] := 0;
        for i := n downto 1 do begin
                d[i] := 1 + d[i+1];
                for j := 1 to M do
                        if a[i] = b[j][1] then begin
                                flag := true;

                                if i + len[j] - 1 > n then
                                        continue;

                                for k := 2 to len[j] do
                                        if b[j][k] <> a[i+k-1] then begin
                                                flag := false;
                                                break;
                                        end;

                                if flag then
                                        d[i] := min(d[i],d[i+len[j]]);
                        end;
        end;
        writeln(FOut,d[1]);
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);

        readln(FIn,N,M);
        for i := 1 to N do
                read(FIn,a[i]);
        readln(FIn);

        for i := 1 to M do begin
                len[i] := 0;
                while (not eoln(FIn)) and (not eof(FIn)) do begin
                        inc(len[i]);
                        read(FIn,b[i][len[i]]);
                end;
                if not eof(FIn) then
                        readln(FIn);
        end;
        solve;
        close(FIn);
        close(FOut);
End.
