Const
        InFile = 'Lines.inp';
        OutFile = 'Lines.out';

        MAXN = 1500;

Type
        PNode = ^TNode;
        TNode = record
                id   : integer;
                next : PNode;
        end;

Var
        FIn,FOut : Text;
        g        : array [1..MAXN] of PNode;
        single   : array [1..MAXN] of integer;
        used     : array [1..MAXN] of boolean;
        d        : array [1..MAXN] of integer;
        n,i,ID   : integer;
        j,k      : integer;
        t,x      : integer;
        z        : integer;

procedure connect(a,b : integer);
var
        w : PNode;

begin
        new(W);
        w^.id := b;
        w^.next := g[a];
        g[a] := w;
end;

procedure clearMem;
var
        i : integer;
        w : PNode;
begin
        for i := 1 to MAXN do
                while g[i] <> nil do begin
                        w := g[i];
                        g[i] := g[i]^.next;
                        dispose(w);
                end;
end;

function dfs(i : integer) : integer;
var
        w : PNode;
        r : integer;

begin
        if used[i] then
                exit;

        used[i] := true;

        r := single[i];
        w := g[i];
        while w <> nil do begin
                r := r + dfs( w^.id);
                w := w^.next;
        end;
        dfs := r;
end;

procedure solve;
var
        i,j : integer;
        res : integer;
begin
        fillchar(used,sizeof(used),false);
        res := 0;
        for i := 1 to N do
                if not used[i] then begin
                        j := dfs(i);
                        if j = 0 then
                                inc(res)
                        else
                                res := res + (j div 2) + (j mod 2);
                end;

        writeln(FOut,res);
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);

        while true do begin

                clearMem;
                fillchar(single,sizeof(single),0);

                readln(FIn,N);

                if n = 0 then
                        break;

                for i := 1 to n do
                        read(FIn,d[i]);

                for z := 1 to N do begin

                        readln(FIn,ID);

                        for i := 1 to d[ID] do begin
                                read(FIn,J);
                                if j = 0 then
                                        if (i = 1) or (i = d[id]) then
                                                inc(single[id]);

                                for k := 1 to J do begin
                                        read(FIn,T,X);
                                        connect(ID,T);
                                end;
                        end;
                end;
                solve;
        end;
        close(FIn);
        close(FOut);
End.
