#include <stdio.h>
#include <math.h>
#define INPF "points.inp"
#define OUTF "points.out"
#define MAXN 1010
#define MIN(a,b) ((a)>(b)?(b):(a))

struct Point{
              float x,y;
            } p[MAXN];
float ds[MAXN][MAXN];
short area[MAXN],used[4*MAXN];
int br,n,cs;
float d;
short res[MAXN];


float Dist(struct Point p1,struct Point p2)
  {return (pow(p1.x-p2.x,2)+pow(p1.y-p2.y,2));}


void Calculate()
  {
    int i,j;
    for(i=0;i<n;i++)
      for(j=i+1;j<n;j++)
        ds[i][j]=Dist(p[i],p[j]);
  }

void FindBr()
  {
    int i,j,done=0,k,stava;
    br=1;
    area[0]=1;
    for(i=0;i<n;i++) area[i]=i+1;
    while(!done)
      {
        done=1;
        for(i=0;i<n;i++)
          for(j=i+1;j<n;j++) if(ds[i][j]<=d && area[i]!=area[j])
            {
              stava=1;
              for(k=0;k<n;k++)
                if(area[k]==area[j]) if(ds[i][k]>d) {stava=0;break;}
              if(stava) {area[j]=area[i]=MIN(area[i],area[j]);done=0;}
            }
      }
    memset(used,0,sizeof(used));
    br=0;
    for(i=0;i<n;i++)
      if(!used[area[i]]) {used[area[i]]=1;br++;}
  }


void Init()
  {
    int i;
    FILE *f=fopen(INPF,"rt");
    cs=0;
    while(1)
      {
        fscanf(f," %d ",&n);
        if(!n || feof(f))
          {
            fclose(f);
            return;
          }
        fscanf(f," %f ",&d);
        d=pow(d,2);
        for(i=0;i<n;i++)
          fscanf(f,"%f %f",&p[i].x,&p[i].y);
        memset(ds,0,sizeof(ds));
        memset(area,0,sizeof(area));
        memset(used,0,sizeof(used));
        Calculate();
        FindBr();
        res[cs++]=br;
      }
  }

void Output()
  {
    int i;
    FILE *f=fopen(OUTF,"wt");
    for(i=0;i<cs;i++)
      fprintf(f,"%d\n",res[i]);
    fclose(f);
  }

int main()
  {
    Init();
    Output();
    return 0;
  }
