#include <stdio.h>

#define WTYP long long
#define WTFMT "%lld\n"

int n;

int red[32];
int used[32];

int usd;

WTYP dyn[1048576];
WTYP no;

FILE* outf;

WTYP check(int p,int l)
{
  int i,u1;
  WTYP r;
  int can[32];

  if (dyn[usd]) { return dyn[usd]; }
  if (p==n)
  {
    return 1;
  }

  for (i=0;i<=l;i++) { can[i]=0; }
  
  for (i=l-1;i>=0;i--)
  {  
    if (used[i]==0) { can[i]=1; break; }
  }
  for (i=l+1;i<n;i++)
  {
    if (used[i]==0) { can[i]=1; }
  }

  r=0;

  for (i=0;i<n;i++)
  {
    if (can[i])
    {
//      red[p]=i;
    
      used[i] = 1;

      u1=usd;
      usd|=(1<<i);
      r+=check(p+1,i);
      usd=u1;
      
      used[i] = 0;
    }
  }

  dyn[usd] = r;

  return r;
}

int mtest(int p,int l)
{
  int i,u1;
  WTYP r;
  int can[32];

  if (p==n)
  {
    fprintf(outf,"%d",red[0]+1);
    for (i=1;i<n;i++)
    {
      fprintf(outf," %d",red[i]+1);
    }
    fprintf(outf,"\n");
    
    return 1;
  }

  for (i=0;i<=l;i++) { can[i]=0; }
  
  for (i=l-1;i>=0;i--)
  {  
    if (used[i]==0) { can[i]=1; break; }
  }
  for (i=l+1;i<n;i++)
  {
    if (used[i]==0) { can[i]=1; }
  }

  r=0;

  for (i=0;i<n;i++)
  {
    if (can[i])
    {
      used[i] = 1;

      u1=usd;
      usd|=(1<<i);
      r=check(p+1,i);
      usd=u1;

      used[i] = 0;

      if (no>r) { no-=r; } else { break; } // This is the position
    }
  }

  used[i] = 1;

  red[p] = i;
  u1=usd;
  usd|=(1<<i);
  r=mtest(p+1,i);
  usd=u1;

  used[i] = 0;

  return 0;
}

int main(void)
{
  WTYP i;
  WTYP r;
  FILE* f;

  f = fopen("fax.inp","rt");
  fscanf(f,"%d ",&n);
  fscanf(f,WTFMT,&i);
  fclose(f);

  outf = fopen("fax.out","wt");

  usd=0;
  r = check(0,-1);
  fprintf(outf,WTFMT,r);

  usd=0;
  no = i;
  mtest(0,-1);

  fclose(outf);

  return 0;
}
