#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define MAXN 51
#define MAXK 16

int arr[MAXK];
int iarr;
int cnt[MAXN];
int nnk[MAXN][MAXK];
int N, M;
int P;



void read_all(void);
void do_all(void);
void init(void);
int encode(void);
void write_all(void);



int main(void)
{
  read_all();
  do_all();
  write_all();
  return 0;
}



void read_all(void)
{
  int i;
  
  for (i = 0; i < 6; i++)  scanf("%d", &arr[i]);
}



void do_all(void)
{
  init();
  P = encode();
}



void init(void)
{
  int n, k, i;

  for (i = 0; i < MAXN; i++)  nnk[i][0] = 1;
  nnk[0][0] = 1;
  for (n = 1; n < MAXN; n++) {
    for (k = 1; k < MAXK; k++) {
      nnk[n][k] = nnk[n-1][k] + nnk[n-1][k-1];
    }
  }
  for (i = 0; i < 6; i++) {
    cnt[arr[i]]++;
  }
  for (i = 0; i < MAXN; i++) {
    while (cnt[i]--) {
      arr[iarr++] = i;
    }
  }
}



int encode(void)
{
  int i, j, c, m;
  int res;

  res = 0;
  m = 49;
  for (i = 0; i < 6; i++) {
    c = arr[i];
    for (j = 1; j < c; j++) {
      res += nnk[m-j][5-i];
    }
    for (j = i+1; j < 6; j++) {
      arr[j] -= c;
    }
    m -= c;
  }
  return res;
}



void write_all(void)
{
  int i;

  for (i = 23; i >= 0; i--) {
    printf("%d", (P>>i)&1);
  }
}
