#include <stdio.h>
#define INPF "fax.inp"
#define OUTF "fax.out"
#define MAXN 20

int perm[MAXN];
int res[MAXN];
int n,k,br=0;
FILE *o;

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    fscanf(f,"%d%d",&n,&k);
    fclose(f);
  }

void Swap(int *a,int *b)
  {
    int tmp=*a;
    *a=*b;
    *b=tmp;
  }

int CheckPerm()
  {
    int i,j,l;
    for(i=0;i<n-2;i++)
      for(j=i+1;j<n;j++)
        for(l=j+1;l<n;l++)
          if(perm[j]<perm[i] && perm[l]<perm[i] && perm[j]<perm[l]) return 0;
/*    for(i=0;i<n;i++)
      fprintf(o,"%d",perm[i]);
    fprintf(o,"\n");*/
    return 1;
  }

void GenPerm()
  {
    int pos,i,min;
    for(i=0;i<n;i++) perm[i]=i+1;
    if(CheckPerm()) br++;
    while(1)
      {
         pos=-1;
         for(i=n-1;i>0;i--)if(perm[i]>perm[i-1]) {pos=i-1;break;}
         if(pos==-1) break;
         min=-1;
         for(i=pos+1;i<n;i++)if(perm[i]>perm[pos] && (perm[i]<perm[min] || min==-1)) min=i;
         Swap(&perm[pos],&perm[min]);
         for(i=1;i<=(n-pos-1)/2;i++)
           Swap(&perm[pos+i],&perm[n-i]);
         if(CheckPerm())
           {
             br++;
             if(br==k) memcpy(res,perm,sizeof(perm));
           }
//         if(perm[0]!=1) break;
      }
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    int i;
    fprintf(f,"%d\n",br);
    for(i=0;i<n;i++)
      if(i!=n-1) fprintf(f,"%d ",res[i]);
            else fprintf(f,"%d\n",res[i]);
    fclose(f);
  }

int main()
  {
    Init();
//    o=fopen(OUTF,"wt");
/*    for(n=3;n<10;n++)
      {*/
//      n=7;
        br=0;
        GenPerm();
//        fprintf(o,"%d : %d\n",n,br);
//      }
//    fclose(o);
    Output();
    return 0;
  }
