const inp = 'assem.inp';
      out = 'assem.out';
      MaxCom = 100000;

type TCell = array[1..10000] of longint;

     TCom = record
            c: byte;
            i: integer;
            end;
     TComArr = array[1..MaxCom] of TCom;

     TSx = array[1..200] of integer;
     TSs = array[1..200] of char;

var Fin, Fout: text;
    Cell: TCell;

    com: TComArr;
    minFree, brC: integer;

    Sx: TSx;
    Ss: TSs;
    brX, brS: byte;

    rez: longint;

{############################################################################}
procedure Done;
begin
close(Fin); close(Fout);
halt;
end;

{############################################################################}
procedure Init;
var i: byte;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);

for i:=1 to 9 do read(Fin, cell[i]);
readln(Fin);

minFree:= 10;
brC:= 0; BrX:= 0; brS:= 0;
end;

{############################################################################}
function AddCom(a, b: integer): integer;

begin
inc(brC); com[brC].c:= 1; com[brC].i:= a;
inc(brC); com[brC].c:= 3; com[brC].i:= b;
inc(brC); com[brC].c:= 2; com[brC].i:= minFree;
inc(minFree);
      if minFree = 10001 then writeLn(Fout, 'mrn! - minFree - add');

cell[com[brC].i]:= cell[a]+cell[b];
AddCom:= com[brC].i;
end;

{############################################################################}
function MulCom(a, b: integer): integer;

begin
inc(brC); com[brC].c:= 1; com[brC].i:= a;
inc(brC); com[brC].c:= 4; com[brC].i:= b;
inc(brC); com[brC].c:= 2; com[brC].i:= minFree;
inc(minFree);
      if minFree = 10001 then writeLn(Fout, 'mrn! - minFree - mul');

cell[com[brC].i]:= cell[a]*cell[b];
MulCom:= com[brC].i;
end;

{############################################################################}
{############################################################################}
{############################################################################}
procedure Solve;
var c: char;
    i: byte;
    l: longint;
    a, b, d: integer;


begin
while not EoLn(Fin) do
  begin
  read(Fin, c);
  {@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
  if (c='+') or (c='*') or (c='(') then
    begin
    inc(brS);
    Ss[brS]:= c;
    continue;
    end;
  {@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
  if c=')' then
    begin
    i:= 0;
    while (brS > 0) and (Ss[brS] = '+') do
      begin inc(i); dec(brS); end;
    if (brS <= 0) or (Ss[brS] <> '(') then writeln(Fout, 'mrn - brS')
    else dec(brS);

    while i > 0 do
      begin
      Sx[brX-1]:= AddCom(Sx[brX-1], Sx[brX]);
      dec(brX);
      dec(i);
      end;

    if (brS > 0) and (Ss[brS] = '*') then
      begin
      Sx[brX-1]:= MulCom(Sx[brX-1], Sx[brX]);
      dec(brX);
      dec(brS);
      end;
    continue;
    end;
  {@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
  if c='X' then
    begin
    inc(brX);
    read(Fin, c);
    Sx[brX]:= ord(c) - 48;

    if (brS > 0) and (Ss[brS] = '*') then
      begin
      Sx[brX-1]:= MulCom(Sx[brX-1], Sx[brX]);
      dec(brX);
      dec(brS);
      end;
    continue;
    end;
  end;

i:= brS;
while i > 0 do
  begin
  Sx[brX-1]:= AddCom(Sx[brX-1], Sx[brX]);
  dec(brX);
  dec(i);
  end;
writeln(Fout, cell[Sx[1]]);
dec(brC);
a:= com[brC-1].i;
b:= com[brC].i;
d:= com[brC-2].i;
if d = a then d:= b else d:= a;
com[brC-2].i:= d;
com[brC-2].c:= com[brC].c;
dec(brC, 2);

writeln(Fout, brC);
for l:=1 to brC do
  case com[l].c of
    1: writeln(Fout, 'LOA ', com[l].i);
    2: writeln(Fout, 'STO ', com[l].i);
    3: writeln(Fout, 'ADD ', com[l].i);
    4: writeln(Fout, 'MUL ', com[l].i);
    end;
end;

{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
Init;
Solve;
Done;
END.
