#include <fstream>
#include <cstring>
#include <iomanip>

ifstream fin("shsh.inp");
ofstream fout("shsh.out");

typedef long long T;

int n,v,s;
int p[32];
T c[32];
T f[32];


T central(int k)
{
  T a[32][512];

  if (p[k]>=v) return f[n];

  memset(a,0,sizeof(a));

  /*
  for (int i=0;i<n;i++)
    if (i!=k)
    {
      for (int j=s;j>p[i];j--)
        if (a[j-p[i]]) a[j]+=a[j-p[i]];
      a[p[i]]++;
    }
  */
  int pc=0;

  for (int i=0;i<n;i++)
    if (i!=k)
    {
      pc++;
      for (int j=s;j>p[i];j--)
        for (int tc=1;tc<pc;tc++)
          if (a[tc][j-p[i]]) a[tc+1][j]+=a[tc][j-p[i]];
      a[1][p[i]]++;
    }

  /*
  cout << "----------------\n";
  for (int i=1;i<=n;i++)
    for (int j=1;j<=s;j++)
      if (a[i][j])
      {
        cout << i << ":" << j << "=" << a[i][j] << "  |" <<
             a[i][j]*f[i] << endl;
      }
  cin.get();
  */


  T r=0;
  for (int j=1;j<=n;j++)
    for (int i=v-p[k];i<v;i++)
      r+=a[j][i]*f[j]*f[n-j-1];

  return r;
}


int main()
{
  f[0]=1;
  for (int i=1;i<=20;i++) f[i]=i*f[i-1];
//  for (int i=1;i<=20;i++) cout << f[i] << " ";

  fin >> n;
  while (n)
  {
    fin >> v;
    s=0;
    for (int i=0;i<n;i++) {fin >> p[i];s+=p[i];}

    for (int i=0;i<n;i++)
      c[i]=central(i);

    fout.flags(ios::fixed);
    for (int i=0;i<n;i++)
    {
      long long x=(long long)1000*c[i]/f[n];
      if (x%10)
        fout << setprecision(1) << (double)100*c[i]/f[n];
      else
        fout << x/10;
      fout << endl;
    }

    fin >> n;
    if (n) fout << endl;
  }

  return 0;
}
