#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define MAXN 1024
#define MAXNSTOPS 1024


int N, nstops[MAXN];
/*int ind[MAXN*MAXNSTOPS];*/
/*int nind;*/
char active[MAXN*MAXNSTOPS];
int deg[MAXN*MAXNSTOPS];
/*int degr[MAXN];*/
char g[MAXN][MAXN];
int start[MAXN];
int comp[MAXN];
int ncomp;
int oddforc[MAXN];
int P;

FILE *fin, *fout;


int read_all(void);
void do_all(void);
void DFS(int u);
void write_all(void);




int main(void)
{
  fin  = fopen("lines.inp", "rt");
  fout = fopen("lines.out", "wt");
  while (read_all()) {
    do_all();
    write_all();
  }
  return 0;
}




int read_all(void)
{
  int i;

  if (fscanf(fin, "%d", &N) != 1)  return 0;
  if (N <= 0)  return 0;
  for (i = 0; i < N; i++) {
    fscanf(fin, "%d", &nstops[i]);
  }
  return 1;
}




void do_all(void)
{
  int i, j, gst, n, k, no, i1;

  gst = 0;
  for (i = 0; i < N; i++) {
    start[i] = gst;
    for (j = 0; j < nstops[i]; j++) {
      active[gst] = 1;
      gst++;
    }
  }
/*  memset(degr, 0, sizeof(degr));*/
  memset(deg, 0, sizeof(deg));
  memset(g, 0, sizeof(g));
/*  nind = 0;*/
  for (i1 = 0; i1 < N; i1++) {
    fscanf(fin, "%d", &i);  i--;
    for (j = 0; j < nstops[i]; j++) {
      fscanf(fin, "%d", &n);
      if (active[start[i]+j] == 0) {
        while (n--) {
          fscanf(fin, "%d %d", &k, &no);  k--;  no--;
        }
        continue;
      }
      deg[start[i]+j] = 2*n+2;
      if (j == 0 || j == nstops[i]-1)  deg[start[i]+j]--;
      while (n--) {
        fscanf(fin, "%d %d", &k, &no);  k--;  no--;
        active[start[k]+no] = 0;
        g[i][k] = g[k][i] = 1;
        if (no == 0 || no == nstops[k]-1)  deg[start[i]+j]--;
      }
    }
  }
  memset(oddforc, 0, sizeof(oddforc));
  memset(comp, 0, sizeof(comp));
  ncomp = 1;
  P = 0;
  for (i = 0; i < N; i++) {
    if (comp[i] > 0)  continue;
    DFS(i);
    P += oddforc[ncomp]/2;
    if (oddforc[ncomp] == 0)  P++;
    ncomp++;
  }
  ncomp--;
}




void DFS(int u)
{
  int i;

  comp[u] = ncomp;
  for (i = 0; i < nstops[u]; i++) {
    if (active[start[u]+i] == 0)  continue;
    oddforc[ncomp] += deg[start[u]+i]%2;
  }

  for (i = 0; i < N; i++) {
    if (g[u][i] && comp[i] == 0) {
      DFS(i);
    }
  }
}



void write_all(void)
{
  fprintf(fout, "%d\n", P);
}

