const inp = 'points.inp';
      out = 'points.out';
      Eps = 0.0001;
      MaxN = 1005;

type TPoint = record
              x,y: real;
              end;
     TPointArr = array[1..MaxN] of Tpoint;
     TGrid = array[1..MaxN, 1..MaxN] of boolean;
     TUsed = array[1..MaxN] of boolean;


var Fin, Fout: Text;
    n, i, j, count: integer;
    p: TPointArr;
    D: real;
    group: TGrid;
    used: TUsed;


{@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
procedure Done;
begin
end;

{@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
function Dist(p1, p2: TPoint): real;
begin
dist:= sqrt(sqr(p1.x - p2.x) + sqr(p1.y - p2.y));
end;

{@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
procedure DFS(ind: integer);
var k: integer;
begin
used[ind]:= true;
for k:= 1 to n do
  if (not used[k]) and (group[ind, k]) then DFS(k);
end;

{@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
Procedure Solve;
begin
for i:=1 to n-1 do
  for j:=i+1 to n do
    if dist(p[i], p[j]) - D > Eps then
      begin
      group[i, j]:= false;
      group[j, i]:= false;
      end
    else
      begin
      group[i, j]:= true;
      group[j, i]:= true;
      end;

Fillchar(used, sizeof(used), false);
count:= 0;
for i:=1 to n do
  if not used[i] then
    begin
    DFS(i);
    inc(count);
    end;
writeln(Fout, count);
end;

{@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
{@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
{@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@}
BEGIN
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);
repeat
  read(Fin, n);
  if n = 0 then break;
  readln(Fin, D);
  for i:= 1 to n do read(Fin, p[i].x, p[i].y); readln(Fin);
  Solve;
until false;
close(Fin); close(Fout);
halt;
END.
