#include <stdio.h>
#include <time.h>
#define INPF "seq.inp"
#define OUTF "seq.out"
#define INF 2000000001
#define SIZE 5000000

int a,b,k=0,x1;
int s[20001];
short p[SIZE];

void Init()
  {
    FILE *f=fopen(INPF,"rt");
    int i;
    fscanf(f,"%d%d",&a,&b);
    fclose(f);
    for(i=a;i<=b;i++)
      s[i-a]=0;
  }

void Output()
  {
    FILE *f=fopen(OUTF,"wt");
    int i;
    fprintf(f,"%d %d\n",x1,k);
    fclose(f);
    exit(0);
  }


int S(int nm)
  {
    int res=0,i;
    for(i=1;i<=nm/2;i++)
      {
        if(nm%i==0) res+=i;
        if(res>nm) return INF;
      }
    return res;
  }

int BR(int num,int prev)
  {
    if(num<1) return 0;
    if(num>=prev) return 0;
    if(num>=a && num<prev) return s[num-a];
    if(num<SIZE)
      {
        if(p[num]) return p[num];
        p[num]=BR(S(num),num)+1;
        return p[num];        
      }
      else return (BR(S(num),num)+1);

  }

void Solve()
  {
    int i,curr,ln,prev;
    p[1]=1;
    for(i=a;i<=b;i++)
      {
        curr=i;ln=0;prev=INF;
        ln=BR(S(curr),curr)+1;
        s[i-a]=ln;
        if(ln>k) {k=ln;x1=i;}
        if( ( ((float)clock()) /CLK_TCK) >4.9)Output();
      }
  }

void PreProcess()
  {
    int i,curr,ln,tmp;
    for(i=1;i<SIZE;i++)
      {
        curr=i;
        tmp=S(i);
        if(tmp<curr) ln=p[tmp];
        p[i]=++ln;
      }
  }

int main()
  {
    clock();
    Init();
    Solve();
    Output();
    return 0;
  }
