const inp = 'fax.inp';
      out = 'fax.out';

type TCom = array[1..19, 1..19] of int64;
     TS = array[1..20] of int64;
     TArr = array[1..20] of byte;
     TUsed = array[1..20] of boolean;
     THighest = array[0..20] of byte;

var Fin, Fout: text;
    n: byte;
    count, k: int64;
    comb: Tcom;
    S: TS;
    a: TArr;
    used: TUsed;
    highest: THighest;

{############################################################################}
procedure Done;
begin
close(Fin); close(Fout);
halt;
end;

{############################################################################}
procedure Init;
var i, j, p: byte;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);
readln(Fin, n);
readln(Fin, k);

for i:=1 to n-1 do
  begin
  for j:=1 to i div 2 do
    begin
    comb[i, j]:= 1;
    for p:= i-j+1 to i do  comb[i, j]:= comb[i, j]*p;
    for p:= 2 to j do  comb[i, j]:= comb[i, j] div p;
    end;
  for j:= i div 2 + 1 to i-1 do  comb[i, j]:= comb[i, i-j];
  end;

fillchar(S, sizeof(S), 0);
S[1]:= 1;
if n = 1 then  begin writeln(Fout, 1); writeln(Fout, 1); done; end;
S[2]:= 2;
if n = 2 then
  begin
  writeln(Fout, 2);
  if k=1 then writeln(Fout, '1 2') else writeln(Fout, '2 1');
  Done;
  end;
S[3]:= 5;
if n = 3 then
  begin
  writeln(Fout, 5);
  if k = 1 then writeln(Fout, '1 2 3');
  if k = 2 then writeln(Fout, '1 3 2');
  if k = 3 then writeln(Fout, '2 1 3');
  if k = 4 then writeln(Fout, '2 3 1');
  if k = 5 then writeln(Fout, '3 2 1');
  Done;
  end;
end;

{############################################################################}
function Fine: boolean;
var i: byte;
begin
for i:= n downto 2 do
  if (a[i] < highest[i]) and (a[i] > a[i-1]) then
    begin Fine:= false; exit; end;
Fine:= true;
end;

{############################################################################}
procedure Fill(p: byte);
var i, j: byte;
begin
if p = n+1 then
  begin
  if fine then inc(count);
  if count = k then
    begin
    write(Fout, a[1]);
    for i:=2 to n do write(Fout, ' ', a[i]);
    writeln(Fout);
    Done;
    end;
  exit;
  end;

j:= 1; while used[j] do inc(j);
for i:=j to n do
  if not used[i] then
    begin
    used[i]:= true;
    a[p]:= i;
    if i > highest[p-1] then highest[p]:= i else highest[p]:= highest[p-1];
    Fill(p+1);
    used[i]:= false;
    end;

end;

{############################################################################}
{############################################################################}
procedure Solve;
var i, j: byte;

    function fact(b: byte): int64;
    var r: int64;
        p: byte;
    begin
    r:= 1; for p:= 2 to b do r:= r*p; fact:= r;
    end;

begin
for i:= 4 to n do  { presmjata S[i] }
  begin
  S[i]:= S[i-1] + 1;
  for j:= 1 to i-2 do  S[i]:= S[i] + comb[i-1, j] * S[i-j-1];
  end;
writeln(Fout, S[n]);

fillchar(used, sizeof(used), false);
if k <= S[n-1] then
  begin
  count:= 0;
  highest[0]:= 0;
  a[1]:= 1;
  highest[1]:= 1;
  Fill(2);
  end;

if k <= 2 * S[n-1] then
  begin
  count:= S[n-1];
  highest[0]:= 0;
  a[1]:= 2;
  highest[1]:= 2;
  Fill(2);
  end;

if k <= 2 * S[n-1] + fact(n-1) - n + 2 then
  begin
  count:= 2 * S[n-1];
  highest[0]:= 0;
  a[1]:= 3;
  highest[1]:= 3;
  Fill(2);
  end;

count:= 0;
highest[0]:= 0;
Fill(1);
end;

{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
Init;
Solve;
Done;
END.