const inp = 'Seq.inp';
      out = 'Seq.out';
      MaxB = 10000000;

type TS = array[1..MaxB] of longint;


var Fin, Fout: text;
    best: byte;
    bestN: longint;
    A, B: longint;
    S: TS;

{############################################################################}
procedure Done;
begin
close(Fin); close(Fout);
halt;
end;

{############################################################################}
procedure Init;

begin
assign(Fin, inp); reset(Fin);
assign(Fout, out); rewrite(Fout);
readln(Fin, A, B);
fillchar(S, sizeof(S), 0);
end;

{############################################################################}
Function Sn(n: longint): longint;
var i, r: longint;

begin
r:= 0;
for i:= n-1 downto 1 do
  if n mod i = 0 then r:= r+i;
Sn:= r;
end;

{############################################################################}
procedure Solve;
var ss, i, n: longint;
    count: byte;
    bad: boolean;

begin
best:= 0;
bestN:= 0;
for i:=A to B do
  begin
  count:= 1;
  n:= i;
  bad:= false;
  while n>MaxB do
    begin
    ss:= Sn(n);
    if ss >= n then
      begin bad:= true; break; end;
    n:= ss;
    inc(count);
    end;
  if bad then continue;

  while n>1 do
    begin
    if S[n] = 0 then S[n]:= Sn(n);
    if S[n] >= n then
      begin bad:= true; break; end;
    n:= S[n];
    inc(count);
    end;
  if bad then continue;

  if count > best then
    begin
    best:= count;
    bestN:= i;
    end;
  end;
writeln(Fout, BestN, ' ', best);
end;

{############################################################################}
{############################################################################}
{############################################################################}
BEGIN
Init;
Solve;
Done;
END.