#include <fstream>
#include <cstring>
#include <iomanip>
#include <cmath>

#define INF 100000000

int n,m;
int x,y;
short l[1024][1024];
short a[1024][1024];
ifstream fin("hill.inp");
ofstream fout("hill.out");


double diiiki(int x,int y)
{
  double cost[1024];
  int p[1024];
  bool v[1024];

  for (int i=0;i<n;i++) {cost[i]=INF;v[i]=false;p[i]=0;}
  cost[x]=0;  p[x]=-1;

  for (int i=0;i<n;i++)
  {
    double min=INF;int ml=-1;
    for (int j=0;j<n;j++)
      if (!v[j])
        if (min>cost[j]) min=cost[ml=j];

    if (ml==-1) break; // ???????????
    v[ml]=true;

    for (int j=1;j<=l[ml][0];j++)
    {
      int u=l[ml][j];
      if (!v[u])
      {
        double nc;
        if (p[ml]==-1)
          nc=cost[ml]+1.0*a[ml][u]/2;
        else
        {
          double d=1.0*a[ml][u]/2-1.0*a[p[ml]][ml]/4;
          if (d<0.00001) nc=cost[ml]; else nc=cost[ml]+d;
        }
        if (nc<cost[u]) {cost[u]=nc;p[u]=ml;}
      }
    }
  }
  
  return abs(cost[y]-INF)<0.0001?0.0:cost[y];
}


int main()
{
  memset(a,0,sizeof(a));
  fin >> n >> m;
  for (int i=0;i<m;i++)
  {
    short x,y,z;
    fin >> x >> y >> z; x--;y--;
    l[x][++l[x][0]]=y;
    l[y][++l[y][0]]=x;
    a[x][y]=a[y][x]=z;
  }
  fin >> x >> y;  x--;y--;

  double r=diiiki(x,y);
  if (r<0.0001)
    fout << "0\n";
  else
    fout << setiosflags(ios::fixed) << setprecision(2) << r << endl;
  
  return 0;
}
