Const
        InFile = 'hill.inp';
        OutFile = 'hill.out';

        MAXN = 1100;
        MAXQUE = 1000000;

Type
        PPNode = ^TTNode;
        TTNode = record
                id   : integer;
                s    : longint;
                next : PPNode;
        end;

        TPos = record
               id,s  : integer;
               b     : real;
        end;

Var
        FIn,FOut : text;
        g        : array [1..MAXN] of PPNode;
        d        : array [1..MAXN,0..1000] of real;
        h        : array [1..MAXN] of real;
        QUE      : array [1..MAXQUE] of TPos;
        fp,count : longint;
        n,m      : longint;
        a,bbbbb  : longint;
        i,j,k,l  : longint;

procedure push(id,s : integer;b : real);
var
        index : longint;
begin
        index := fp + count;
        if index > MAXQUE then
                index := index - MAXQUE;
        que[index].id := id;
        que[index].b := b;
        que[index].s := s;

        inc(count);
end;

procedure pop(var id,s : integer;var b : real);
begin
        id := que[fp].id;
        b := que[fp].b;
        s := que[fp].s;
        dec(count);
        inc(fp);
        if fp > MAXQUE then
                fp := fp - maxque;
end;

procedure connect(a,b,l : longint);
var
        w : PPNode;

begin
        new(W);
        w^.s := l;
        w^.id := b;
        w^.next := g[a];
        g[a] := w;
end;

procedure solve;
var
        i,j   : longint;
        w     : PPnode;
        id,s  : integer;
        b     : real;
        bb,ss : real;

begin
        fp := 1;
        count := 0;

        d[a,0] := 1;

        push(a,0,1);


        while count > 0 do begin
                pop(id,s,b);

                if d[id,s] < b then
                        continue;
                w := g[id];

                while w <> nil do begin
                        bb := w^.s / 2 - s / 4;
                        if bb < 0 then
                                bb := 0;

                        bb := bb + d[id,s];

                        if (d[w^.id,w^.s] = 0) or
                           (d[w^.id,w^.s] > bb) then begin

                           d[w^.id,w^.s] := bb;
                           push(w^.id,w^.s,bb);
                        end;
                        w  := w^.next;
                end;
        end;
        b := 1000000;
        for i := 1 to 1000 do
                if (d[bbbbb,i] > 0) and
                   (d[bbbbb,i] < b) then
                         b := d[bbbbb,i];
        if b = 1000000 then begin
                b := 0;
                writeln(FOut,0);
        end
        else begin
                b := b - 1;
                writeln(FOut,b:0:2);
        end;
end;

Begin
        assign(FIn,InFile);     reset(FIn);
        assign(FOut,OutFile);   rewrite(FOut);
        readln(FIn,N,M);
        for i := 1 to M do begin
                readln(FIn,j,k,l);
                connect(j,k,l);
                connect(k,j,l);
        end;
        readln(Fin,a,bbbbb);
        close(FIn);
        solve;
        close(FOut);
End.
